// automatically generated by spin2cpp v4.2.2-beta-v4.2.1-6-g82de39ff on Thu Jun 18 09:39:14 2020
// command line: /home/ersmith/Parallax/spin2cpp/build/spin2cpp -I.. --p2 --ccode vgatext.spin 

/* 
'******************************
'*  VGA tiled image driver
'******************************

Runs in its own COG. See README.txt for theory of operation.

Four variants are provided:

8 bytes/char: uses full 24 bit color with all effects available
4 bytes/char: uses 8bpp for foreground and background, all effects available
2 bytes/char: uses 16 colors (4bpp) with blinking effect
1 byte/char:  only allows 128 characters, 1 bit for blinking, no colors

Methods:

start(params)
  Starts the driver. "params" is a pointer to a block of 32 bit parameters longs:
  params[0]: base pin to use for the VGA
  params[1]: pointer to screen buffer
  params[2]: number of columns
  params[3]: number of rows
  params[4]: pointer to font data
  params[5]: font width (for now, must be 8)
  params[6]: font height
  params[7]: pixel clock scaling value ($8000_0000 * pixel_clock / system_clock)
  params[8]: horizontal front porch
  params[9]: hsync pulse length
  params[10]: vertical front porch
  params[11]: vsync lines
  params[12]: vertical back porch
  params[13]: polarity: %00 = both positive, %10 = vertical negative, %01 = horizontal negative
  params[14]: cell size, i.e. bytes per character (1, 2, 4, or 8)
  
  returns 1 + the number of the COG used, or 0 on failure
 */
#include <propeller2.h>
#include "vga_tile_driver.h"

#if defined(__GNUC__)
#define INLINE__ static inline
#define Yield__() __asm__ volatile( "" ::: "memory" )
#else
#define INLINE__ static
#define Yield__()
#endif

INLINE__ int32_t Shr__(uint32_t a, uint32_t b) { return (a>>b); }
static  int32_t vga_tile_driver_check_hw_rev(void);

static char dat[] = {
  0x61, 0x01, 0x04, 0xfb, 0x61, 0x03, 0x04, 0xfb, 0x61, 0x05, 0x04, 0xfb, 0x61, 0x07, 0x04, 0xfb, 
  0x61, 0x09, 0x04, 0xfb, 0x61, 0x0b, 0x04, 0xfb, 0x61, 0x0d, 0x04, 0xfb, 0x61, 0x0f, 0x04, 0xfb, 
  0x61, 0x11, 0x04, 0xfb, 0x61, 0x13, 0x04, 0xfb, 0x61, 0x15, 0x04, 0xfb, 0x61, 0x17, 0x04, 0xfb, 
  0x61, 0x19, 0x04, 0xfb, 0x61, 0x1b, 0x04, 0xfb, 0x61, 0x1d, 0x04, 0xfb, 0x61, 0x1f, 0x04, 0xfb, 
  0x02, 0x20, 0x00, 0xf6, 0x01, 0x20, 0x44, 0xf0, 0x06, 0x22, 0x00, 0xf6, 0x01, 0x22, 0x44, 0xf0, 
  0x02, 0x26, 0x00, 0xf6, 0x0f, 0x26, 0x00, 0xfa, 0x13, 0x28, 0x00, 0xf6, 0x3f, 0x28, 0x04, 0xf1, 
  0x06, 0x28, 0x44, 0xf0, 0x02, 0x2a, 0x00, 0xf6, 0x05, 0x2a, 0x00, 0xfa, 0x03, 0x2c, 0x00, 0xf6, 
  0x06, 0x2c, 0x00, 0xfa, 0x05, 0xa2, 0x00, 0xf1, 0x05, 0xa4, 0x00, 0xf1, 0x08, 0x9a, 0x00, 0xf1, 
  0x09, 0x9c, 0x00, 0xf1, 0x0a, 0x9e, 0x00, 0xf1, 0x15, 0xa0, 0x00, 0xf1, 0x01, 0x32, 0x60, 0xfd, 
  0x08, 0x32, 0x64, 0xf0, 0x19, 0x96, 0x40, 0xf5, 0x19, 0x98, 0x40, 0xf5, 0x1d, 0x0e, 0x60, 0xfd, 
  0x00, 0x24, 0x00, 0xf6, 0x04, 0x24, 0x04, 0xf1, 0x02, 0x1c, 0xd4, 0xf7, 0x5a, 0x24, 0x60, 0xfd, 
  0x01, 0x1c, 0xd4, 0xf7, 0x09, 0x68, 0x44, 0xf4, 0x00, 0x00, 0xa8, 0xff, 0x38, 0x00, 0x64, 0xfd, 
  0x00, 0x28, 0x80, 0xff, 0x39, 0x00, 0x64, 0xfd, 0x28, 0x00, 0x80, 0xff, 0x3a, 0x00, 0x64, 0xfd, 
  0x3c, 0x40, 0x64, 0xfd, 0x00, 0x96, 0x00, 0xfc, 0x41, 0x00, 0x60, 0xfd, 0x01, 0x00, 0x04, 0xf1, 
  0x00, 0x98, 0x00, 0xfc, 0x41, 0x00, 0x60, 0xfd, 0x01, 0x00, 0x04, 0xf1, 0x00, 0x98, 0x00, 0xfc, 
  0x41, 0x00, 0x60, 0xfd, 0x01, 0x00, 0x04, 0xf1, 0x00, 0x98, 0x00, 0xfc, 0x41, 0x00, 0x60, 0xfd, 
  0xf9, 0xef, 0x03, 0xf6, 0x0f, 0x1e, 0x80, 0xf7, 0x96, 0x1f, 0x94, 0xf9, 0x00, 0xee, 0x03, 0xf1, 
  0x29, 0xbc, 0x64, 0xfd, 0xf7, 0x41, 0x03, 0xfb, 0x03, 0x00, 0x00, 0xff, 0x68, 0xf2, 0x07, 0xf1, 
  0x29, 0x3e, 0x65, 0xfd, 0x80, 0x01, 0x06, 0xfb, 0x00, 0x03, 0x80, 0xfd, 0x40, 0x00, 0x16, 0x00, 
  0x40, 0x00, 0x17, 0x00, 0x00, 0x00, 0x01, 0x7f, 0x00, 0x00, 0x01, 0x7f, 0x00, 0x00, 0x01, 0x7f, 
  0x00, 0x00, 0x01, 0x7f, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x01, 0x0f, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 
  0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x80, 0x00, 0x80, 0x00, 0x00, 0x00, 0x80, 0x00, 0x80, 
  0x00, 0x80, 0x80, 0x00, 0x00, 0xc0, 0xc0, 0xc0, 0x00, 0x80, 0x80, 0x80, 0x00, 0x00, 0x00, 0xff, 
  0x00, 0x00, 0xff, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0xff, 0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 
  0x00, 0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x00, 
  0x00, 0x66, 0x00, 0x00, 0x00, 0x99, 0x00, 0x00, 0x00, 0xcc, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00, 
  0x00, 0x00, 0x33, 0x00, 0x00, 0x33, 0x33, 0x00, 0x00, 0x66, 0x33, 0x00, 0x00, 0x99, 0x33, 0x00, 
  0x00, 0xcc, 0x33, 0x00, 0x00, 0xff, 0x33, 0x00, 0x00, 0x00, 0x66, 0x00, 0x00, 0x33, 0x66, 0x00, 
  0x00, 0x66, 0x66, 0x00, 0x00, 0x99, 0x66, 0x00, 0x00, 0xcc, 0x66, 0x00, 0x00, 0xff, 0x66, 0x00, 
  0x00, 0x00, 0x99, 0x00, 0x00, 0x33, 0x99, 0x00, 0x00, 0x66, 0x99, 0x00, 0x00, 0x99, 0x99, 0x00, 
  0x00, 0xcc, 0x99, 0x00, 0x00, 0xff, 0x99, 0x00, 0x00, 0x00, 0xcc, 0x00, 0x00, 0x33, 0xcc, 0x00, 
  0x00, 0x66, 0xcc, 0x00, 0x00, 0x99, 0xcc, 0x00, 0x00, 0xcc, 0xcc, 0x00, 0x00, 0xff, 0xcc, 0x00, 
  0x00, 0x00, 0xff, 0x00, 0x00, 0x33, 0xff, 0x00, 0x00, 0x66, 0xff, 0x00, 0x00, 0x99, 0xff, 0x00, 
  0x00, 0xcc, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00, 0x33, 0x00, 0x33, 0x00, 0x33, 
  0x00, 0x66, 0x00, 0x33, 0x00, 0x99, 0x00, 0x33, 0x00, 0xcc, 0x00, 0x33, 0x00, 0xff, 0x00, 0x33, 
  0x00, 0x00, 0x33, 0x33, 0x00, 0x33, 0x33, 0x33, 0x00, 0x66, 0x33, 0x33, 0x00, 0x99, 0x33, 0x33, 
  0x00, 0xcc, 0x33, 0x33, 0x00, 0xff, 0x33, 0x33, 0x00, 0x00, 0x66, 0x33, 0x00, 0x33, 0x66, 0x33, 
  0x00, 0x66, 0x66, 0x33, 0x00, 0x99, 0x66, 0x33, 0x00, 0xcc, 0x66, 0x33, 0x00, 0xff, 0x66, 0x33, 
  0x00, 0x00, 0x99, 0x33, 0x00, 0x33, 0x99, 0x33, 0x00, 0x66, 0x99, 0x33, 0x00, 0x99, 0x99, 0x33, 
  0x00, 0xcc, 0x99, 0x33, 0x00, 0xff, 0x99, 0x33, 0x00, 0x00, 0xcc, 0x33, 0x00, 0x33, 0xcc, 0x33, 
  0x00, 0x66, 0xcc, 0x33, 0x00, 0x99, 0xcc, 0x33, 0x00, 0xcc, 0xcc, 0x33, 0x00, 0xff, 0xcc, 0x33, 
  0x00, 0x00, 0xff, 0x33, 0x00, 0x33, 0xff, 0x33, 0x00, 0x66, 0xff, 0x33, 0x00, 0x99, 0xff, 0x33, 
  0x00, 0xcc, 0xff, 0x33, 0x00, 0xff, 0xff, 0x33, 0x00, 0x00, 0x00, 0x66, 0x00, 0x33, 0x00, 0x66, 
  0x00, 0x66, 0x00, 0x66, 0x00, 0x99, 0x00, 0x66, 0x00, 0xcc, 0x00, 0x66, 0x00, 0xff, 0x00, 0x66, 
  0x00, 0x00, 0x33, 0x66, 0x00, 0x33, 0x33, 0x66, 0x00, 0x66, 0x33, 0x66, 0x00, 0x99, 0x33, 0x66, 
  0x00, 0xcc, 0x33, 0x66, 0x00, 0xff, 0x33, 0x66, 0x00, 0x00, 0x66, 0x66, 0x00, 0x33, 0x66, 0x66, 
  0x00, 0x66, 0x66, 0x66, 0x00, 0x99, 0x66, 0x66, 0x00, 0xcc, 0x66, 0x66, 0x00, 0xff, 0x66, 0x66, 
  0x00, 0x00, 0x99, 0x66, 0x00, 0x33, 0x99, 0x66, 0x00, 0x66, 0x99, 0x66, 0x00, 0x99, 0x99, 0x66, 
  0x00, 0xcc, 0x99, 0x66, 0x00, 0xff, 0x99, 0x66, 0x00, 0x00, 0xcc, 0x66, 0x00, 0x33, 0xcc, 0x66, 
  0x00, 0x66, 0xcc, 0x66, 0x00, 0x99, 0xcc, 0x66, 0x00, 0xcc, 0xcc, 0x66, 0x00, 0xff, 0xcc, 0x66, 
  0x00, 0x00, 0xff, 0x66, 0x00, 0x33, 0xff, 0x66, 0x00, 0x66, 0xff, 0x66, 0x00, 0x99, 0xff, 0x66, 
  0x00, 0xcc, 0xff, 0x66, 0x00, 0xff, 0xff, 0x66, 0x00, 0x00, 0x00, 0x99, 0x00, 0x33, 0x00, 0x99, 
  0x00, 0x66, 0x00, 0x99, 0x00, 0x99, 0x00, 0x99, 0x00, 0xcc, 0x00, 0x99, 0x00, 0xff, 0x00, 0x99, 
  0x00, 0x00, 0x33, 0x99, 0x00, 0x33, 0x33, 0x99, 0x00, 0x66, 0x33, 0x99, 0x00, 0x99, 0x33, 0x99, 
  0x00, 0xcc, 0x33, 0x99, 0x00, 0xff, 0x33, 0x99, 0x00, 0x00, 0x66, 0x99, 0x00, 0x33, 0x66, 0x99, 
  0x00, 0x66, 0x66, 0x99, 0x00, 0x99, 0x66, 0x99, 0x00, 0xcc, 0x66, 0x99, 0x00, 0xff, 0x66, 0x99, 
  0x00, 0x00, 0x99, 0x99, 0x00, 0x33, 0x99, 0x99, 0x00, 0x66, 0x99, 0x99, 0x00, 0x99, 0x99, 0x99, 
  0x00, 0xcc, 0x99, 0x99, 0x00, 0xff, 0x99, 0x99, 0x00, 0x00, 0xcc, 0x99, 0x00, 0x33, 0xcc, 0x99, 
  0x00, 0x66, 0xcc, 0x99, 0x00, 0x99, 0xcc, 0x99, 0x00, 0xcc, 0xcc, 0x99, 0x00, 0xff, 0xcc, 0x99, 
  0x00, 0x00, 0xff, 0x99, 0x00, 0x33, 0xff, 0x99, 0x00, 0x66, 0xff, 0x99, 0x00, 0x99, 0xff, 0x99, 
  0x00, 0xcc, 0xff, 0x99, 0x00, 0xff, 0xff, 0x99, 0x00, 0x00, 0x00, 0xcc, 0x00, 0x33, 0x00, 0xcc, 
  0x00, 0x66, 0x00, 0xcc, 0x00, 0x99, 0x00, 0xcc, 0x00, 0xcc, 0x00, 0xcc, 0x00, 0xff, 0x00, 0xcc, 
  0x00, 0x00, 0x33, 0xcc, 0x00, 0x33, 0x33, 0xcc, 0x00, 0x66, 0x33, 0xcc, 0x00, 0x99, 0x33, 0xcc, 
  0x00, 0xcc, 0x33, 0xcc, 0x00, 0xff, 0x33, 0xcc, 0x00, 0x00, 0x66, 0xcc, 0x00, 0x33, 0x66, 0xcc, 
  0x00, 0x66, 0x66, 0xcc, 0x00, 0x99, 0x66, 0xcc, 0x00, 0xcc, 0x66, 0xcc, 0x00, 0xff, 0x66, 0xcc, 
  0x00, 0x00, 0x99, 0xcc, 0x00, 0x33, 0x99, 0xcc, 0x00, 0x66, 0x99, 0xcc, 0x00, 0x99, 0x99, 0xcc, 
  0x00, 0xcc, 0x99, 0xcc, 0x00, 0xff, 0x99, 0xcc, 0x00, 0x00, 0xcc, 0xcc, 0x00, 0x33, 0xcc, 0xcc, 
  0x00, 0x66, 0xcc, 0xcc, 0x00, 0x99, 0xcc, 0xcc, 0x00, 0xcc, 0xcc, 0xcc, 0x00, 0xff, 0xcc, 0xcc, 
  0x00, 0x00, 0xff, 0xcc, 0x00, 0x33, 0xff, 0xcc, 0x00, 0x66, 0xff, 0xcc, 0x00, 0x99, 0xff, 0xcc, 
  0x00, 0xcc, 0xff, 0xcc, 0x00, 0xff, 0xff, 0xcc, 0x00, 0x00, 0x00, 0xff, 0x00, 0x33, 0x00, 0xff, 
  0x00, 0x66, 0x00, 0xff, 0x00, 0x99, 0x00, 0xff, 0x00, 0xcc, 0x00, 0xff, 0x00, 0xff, 0x00, 0xff, 
  0x00, 0x00, 0x33, 0xff, 0x00, 0x33, 0x33, 0xff, 0x00, 0x66, 0x33, 0xff, 0x00, 0x99, 0x33, 0xff, 
  0x00, 0xcc, 0x33, 0xff, 0x00, 0xff, 0x33, 0xff, 0x00, 0x00, 0x66, 0xff, 0x00, 0x33, 0x66, 0xff, 
  0x00, 0x66, 0x66, 0xff, 0x00, 0x99, 0x66, 0xff, 0x00, 0xcc, 0x66, 0xff, 0x00, 0xff, 0x66, 0xff, 
  0x00, 0x00, 0x99, 0xff, 0x00, 0x33, 0x99, 0xff, 0x00, 0x66, 0x99, 0xff, 0x00, 0x99, 0x99, 0xff, 
  0x00, 0xcc, 0x99, 0xff, 0x00, 0xff, 0x99, 0xff, 0x00, 0x00, 0xcc, 0xff, 0x00, 0x33, 0xcc, 0xff, 
  0x00, 0x66, 0xcc, 0xff, 0x00, 0x99, 0xcc, 0xff, 0x00, 0xcc, 0xcc, 0xff, 0x00, 0xff, 0xcc, 0xff, 
  0x00, 0x00, 0xff, 0xff, 0x00, 0x33, 0xff, 0xff, 0x00, 0x66, 0xff, 0xff, 0x00, 0x99, 0xff, 0xff, 
  0x00, 0xcc, 0xff, 0xff, 0x00, 0xff, 0xff, 0xff, 0x00, 0x08, 0x08, 0x08, 0x00, 0x12, 0x12, 0x12, 
  0x00, 0x1c, 0x1c, 0x1c, 0x00, 0x26, 0x26, 0x26, 0x00, 0x30, 0x30, 0x30, 0x00, 0x3a, 0x3a, 0x3a, 
  0x00, 0x44, 0x44, 0x44, 0x00, 0x4e, 0x4e, 0x4e, 0x00, 0x58, 0x58, 0x58, 0x00, 0x62, 0x62, 0x62, 
  0x00, 0x6c, 0x6c, 0x6c, 0x00, 0x76, 0x76, 0x76, 0x00, 0x80, 0x80, 0x80, 0x00, 0x8a, 0x8a, 0x8a, 
  0x00, 0x94, 0x94, 0x94, 0x00, 0x9e, 0x9e, 0x9e, 0x00, 0xa8, 0xa8, 0xa8, 0x00, 0xb2, 0xb2, 0xb2, 
  0x00, 0xbc, 0xbc, 0xbc, 0x00, 0xc6, 0xc6, 0xc6, 0x00, 0xd0, 0xd0, 0xd0, 0x00, 0xda, 0xda, 0xda, 
  0x00, 0xe4, 0xe4, 0xe4, 0x00, 0xee, 0xee, 0xee, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x74, 0x08, 0x00, 0x00, 0xf0, 0x07, 0x00, 0x00, 
  0x70, 0x07, 0x00, 0x00, 0x08, 0x07, 0x00, 0x00, 0x0b, 0x38, 0x00, 0xf6, 0x74, 0x00, 0xb0, 0xfd, 
  0x01, 0x2e, 0x00, 0xf6, 0x04, 0x30, 0x00, 0xf6, 0x06, 0x34, 0x00, 0xf6, 0x01, 0xaa, 0x04, 0xf1, 
  0x20, 0xaa, 0xcc, 0xf7, 0xff, 0xa8, 0x04, 0xa6, 0x0f, 0xa8, 0x04, 0x56, 0x16, 0x38, 0x00, 0xf6, 
  0x5c, 0x00, 0xb0, 0xfd, 0x17, 0x28, 0x70, 0xfc, 0x01, 0x34, 0x8c, 0xf1, 0x06, 0x34, 0x00, 0xa6, 
  0x04, 0x30, 0x00, 0xa6, 0x13, 0x2e, 0x00, 0xa1, 0x91, 0xa6, 0x04, 0xf6, 0x01, 0x34, 0x0c, 0xf2, 
  0x22, 0xa6, 0x44, 0xa5, 0x11, 0x34, 0x08, 0xf2, 0x44, 0xa6, 0x44, 0xa5, 0x54, 0xa6, 0x00, 0xf5, 
  0xa0, 0x03, 0xa0, 0xfd, 0xf2, 0x39, 0x6c, 0xfb, 0x0d, 0x38, 0x00, 0xf6, 0x14, 0x00, 0xb0, 0xfd, 
  0x5f, 0x24, 0x60, 0xfd, 0x0c, 0x38, 0x00, 0xf6, 0x08, 0x00, 0xb0, 0xfd, 0x5f, 0x24, 0x60, 0xfd, 
  0x84, 0xff, 0x9f, 0xfd, 0x08, 0x00, 0xb0, 0xfd, 0x00, 0xa0, 0xc4, 0xfc, 0xfd, 0x39, 0x6c, 0x0b, 
  0x00, 0x9a, 0xc4, 0xfc, 0x01, 0x9c, 0xc4, 0xfc, 0x00, 0x9e, 0xc4, 0xfc, 0x28, 0x7e, 0x64, 0xfd, 
  0x18, 0xac, 0x02, 0xfb, 0x00, 0x31, 0x04, 0x01, 0x10, 0x30, 0xd8, 0xfc, 0x12, 0x40, 0x60, 0xfd, 
  0x12, 0x3e, 0x60, 0xfd, 0x20, 0x3a, 0xe0, 0xf8, 0x53, 0x3e, 0xc8, 0xf7, 0xff, 0x40, 0x24, 0xf5, 
  0xff, 0x3e, 0x24, 0xf5, 0x56, 0x3b, 0x6c, 0xf9, 0x00, 0x3a, 0xe0, 0xf8, 0xff, 0x3a, 0x44, 0x55, 
  0x1d, 0xa2, 0xc0, 0xfc, 0x00, 0x3e, 0x34, 0xfc, 0x01, 0x40, 0x34, 0xfc, 0x12, 0x40, 0x60, 0xfd, 
  0x12, 0x3e, 0x60, 0xfd, 0x20, 0x3a, 0xe0, 0xf8, 0x53, 0x3e, 0xc8, 0xf7, 0xff, 0x40, 0x24, 0xf5, 
  0xff, 0x3e, 0x24, 0xf5, 0x56, 0x3b, 0x6c, 0xf9, 0x00, 0x3a, 0xe0, 0xf8, 0xff, 0x3a, 0x44, 0x55, 
  0x1d, 0xa4, 0xc0, 0xfc, 0x20, 0x3e, 0x34, 0xfc, 0x21, 0x40, 0x34, 0xfc, 0x2d, 0x00, 0x64, 0xfd, 
  0x10, 0x3c, 0xd8, 0xfc, 0x10, 0x40, 0x60, 0xfd, 0x10, 0x3e, 0x60, 0xfd, 0x10, 0x3a, 0x60, 0xfd, 
  0x10, 0x3c, 0x70, 0xfd, 0x56, 0x40, 0x94, 0xf9, 0x00, 0x40, 0x00, 0xf6, 0x56, 0x3e, 0x94, 0xf9, 
  0x00, 0x3e, 0x00, 0xf6, 0x56, 0x3b, 0x6c, 0xf9, 0x00, 0x3a, 0xe0, 0xf8, 0x53, 0x3c, 0x08, 0xf5, 
  0xff, 0x3a, 0xa4, 0x55, 0x1d, 0xa2, 0xc0, 0xfc, 0x00, 0x3e, 0x34, 0xfc, 0x01, 0x40, 0x34, 0xfc, 
  0x10, 0x40, 0x60, 0xfd, 0x10, 0x3e, 0x60, 0xfd, 0x10, 0x3a, 0x60, 0xfd, 0x10, 0x3c, 0x70, 0xfd, 
  0x56, 0x40, 0x94, 0xf9, 0x00, 0x40, 0x00, 0xf6, 0x56, 0x3e, 0x94, 0xf9, 0x00, 0x3e, 0x00, 0xf6, 
  0x56, 0x3b, 0x6c, 0xf9, 0x00, 0x3a, 0xe0, 0xf8, 0x53, 0x3c, 0x08, 0xf5, 0xff, 0x3a, 0xa4, 0x55, 
  0x1d, 0xa4, 0xc0, 0xfc, 0x20, 0x3e, 0x34, 0xfc, 0x21, 0x40, 0x34, 0xfc, 0x2d, 0x00, 0x64, 0xfd, 
  0x80, 0xa6, 0x04, 0xf5, 0x10, 0x3c, 0xd8, 0xfc, 0x10, 0x3a, 0x60, 0xfd, 0x10, 0x3c, 0x70, 0xfd, 
  0x1e, 0x40, 0x40, 0xf8, 0x1e, 0x3e, 0x48, 0xf8, 0x56, 0x40, 0x94, 0xf9, 0x00, 0x40, 0x00, 0xf6, 
  0x56, 0x3e, 0x94, 0xf9, 0x00, 0x3e, 0x00, 0xf6, 0x56, 0x3b, 0x6c, 0xf9, 0x00, 0x3a, 0xe0, 0xf8, 
  0x53, 0x3c, 0xc8, 0xf7, 0xff, 0x3a, 0x64, 0x55, 0x1d, 0xa2, 0xc0, 0xfc, 0x00, 0x3e, 0x34, 0xfc, 
  0x01, 0x40, 0x34, 0xfc, 0x10, 0x3a, 0x60, 0xfd, 0x10, 0x3c, 0x70, 0xfd, 0x1e, 0x40, 0x40, 0xf8, 
  0x1e, 0x3e, 0x48, 0xf8, 0x56, 0x40, 0x94, 0xf9, 0x00, 0x40, 0x00, 0xf6, 0x56, 0x3e, 0x94, 0xf9, 
  0x00, 0x3e, 0x00, 0xf6, 0x56, 0x3b, 0x6c, 0xf9, 0x00, 0x3a, 0xe0, 0xf8, 0x53, 0x3c, 0xc8, 0xf7, 
  0xff, 0x3a, 0x64, 0x55, 0x1d, 0xa4, 0xc0, 0xfc, 0x20, 0x3e, 0x34, 0xfc, 0x21, 0x40, 0x34, 0xfc, 
  0x2d, 0x00, 0x64, 0xfd, 0x5d, 0x40, 0x00, 0xf6, 0x56, 0x3e, 0x00, 0xf6, 0x00, 0x3e, 0x34, 0xfc, 
  0x01, 0x40, 0x34, 0xfc, 0x20, 0x3e, 0x34, 0xfc, 0x21, 0x40, 0x34, 0xfc, 0x80, 0xa6, 0x04, 0xf5, 
  0x10, 0x20, 0xd8, 0xfc, 0x10, 0x3a, 0x60, 0xfd, 0x1d, 0x3c, 0x00, 0xf6, 0x7f, 0x3a, 0x04, 0xf5, 
  0x53, 0x3c, 0x08, 0xf5, 0x56, 0x3b, 0x6c, 0xf9, 0x00, 0x3a, 0xe0, 0xf8, 0xff, 0x3a, 0x64, 0x55, 
  0x1d, 0xa2, 0xc0, 0xfc, 0x10, 0x3a, 0x60, 0xfd, 0x1d, 0x3c, 0x00, 0xf6, 0x7f, 0x3a, 0x04, 0xf5, 
  0x53, 0x3c, 0x08, 0xf5, 0x56, 0x3b, 0x6c, 0xf9, 0x00, 0x3a, 0xe0, 0xf8, 0xff, 0x3a, 0x64, 0x55, 
  0x1d, 0xa4, 0xc0, 0xfc, 0x2d, 0x00, 0x64, 0xfd, 0xf9, 0xef, 0x03, 0xf6, 0x28, 0x02, 0x64, 0xfd, 
  0xe1, 0xc1, 0x07, 0xfb, 0xf9, 0xef, 0xc3, 0xf2, 0x02, 0xee, 0x4f, 0xf0, 0x01, 0xee, 0x07, 0xa6, 
  0x00, 0xef, 0x67, 0xfc, 0x01, 0xec, 0x63, 0xfd, 0x03, 0xec, 0x63, 0xfd, 
};
int32_t vga_tile_driver_start(vga_tile_driver *self, int32_t params)
{
  int32_t 	ptr, tmp;
  // check what kind of hardware we are using
  if (self->hw_rev == 0) {
    self->hw_rev = vga_tile_driver_check_hw_rev();
  }
  if (self->hw_rev == 1) {
    // RevA (old) silicon
    // change streamer commands
    ptr = (int32_t)(((int32_t *)&dat[308]));
    tmp = -822083584;
    // before sync
    ((int32_t *)ptr)[0] = tmp;
    // sync
    ((int32_t *)ptr)[1] = tmp;
    // before visible
    ((int32_t *)ptr)[2] = tmp;
    // visible
    ((int32_t *)ptr)[3] = tmp;
    ptr = (int32_t)(((int32_t *)&dat[324]));
    // even characters
    ((int32_t *)ptr)[0] = -1895825408;
    // odd characters (different LUT base)
    ((int32_t *)ptr)[1] = -1895759872;
  } else {
    // new silicon
    ptr = (int32_t)(((int32_t *)&dat[308]));
    tmp = 2130771968;
    ((int32_t *)ptr)[0] = tmp;
    ((int32_t *)ptr)[1] = tmp;
    ((int32_t *)ptr)[2] = tmp;
    ((int32_t *)ptr)[3] = tmp;
    ptr = (int32_t)(((int32_t *)&dat[324]));
    // even characters
    ((int32_t *)ptr)[0] = 251658240;
    // odd characters
    ((int32_t *)ptr)[1] = 251723776;
  }
  self->mycog = _cognew((int32_t)(((int32_t *)&dat[0])), params) + 1;
  return self->mycog;
}

//
// check the hardware revision
// return 1 for original silicon, 2 for new silicon
// the difference is in how setq+rdlong works for ptra offsets;
// ptra++ is applied the appropriate number of times in rev 2 silicon
//
static int32_t vga_tile_driver_check_hw_rev(void)
{
  int32_t _local__0001[1];
  _local__0001[0] = 0;
  _cognew((int32_t)(((int32_t *)&dat[2264])), (int32_t)(&_local__0001[0]));
  while (_local__0001[0] == 0) {
    Yield__();
  }
  return _local__0001[0];
}

void vga_tile_driver_stop(vga_tile_driver *self)
{
  if (self->mycog) {
    _cogstop(self->mycog - 1);
    self->mycog = 0;
  }
}

int32_t vga_tile_driver_calcscale(int32_t a, int32_t b)
{
  int32_t 	shiftcnt;
  shiftcnt = VGA_TILE_DRIVER_PIXSHIFT;
  // remove factors of 5 (will be pretty common)
  while ((0 == (a % 5)) && (0 == (b % 5))) {
    a = a / 5;
    b = b / 5;
  }
  // scale a up as much as we can
  while (((a & 0x40000000) == 0) && (shiftcnt > 0)) {
    a = a << 1;
    (shiftcnt--);
  }
  while (((b & 0x1) == 0) && (shiftcnt > 0)) {
    b = Shr__(b, 1);
    (shiftcnt--);
  }
  return ((a / b) << shiftcnt);
}

